//--
// This file is part of Sonic Pi: http://sonic-pi.net
// Full project source: https://github.com/samaaron/sonic-pi
// License: https://github.com/samaaron/sonic-pi/blob/master/LICENSE.md
//
// Copyright 2013, 2014 by Sam Aaron (http://sam.aaron.name).
// All rights reserved.
//
// Permission is granted for use, copying, modification, distribution,
// and distribution of modified versions of this work as long as this
// notice is included.
//++

// AUTO-GENERATED-DOCS
// Do not manually add any code below this comment
// otherwise it may be removed

void MainWindow::initDocsWindow() {

  QString systemLocale = QLocale::system().name();

if (systemLocale.startsWith("pl")) {

  // language pl

  // tutorial info
  struct help_page tutorialHelpPages[] = {
    { "1 Witaj w Sonic Pi", NULL, "qrc:///help/tutorial_item_1.html"},
    { QString::fromUtf8("   1.1 Kodowanie na żywo"), NULL, "qrc:///help/tutorial_item_2.html"},
    { QString::fromUtf8("   1.2 Zapoznanie z interfejsem użytkownika"), NULL, "qrc:///help/tutorial_item_3.html"},
    { QString::fromUtf8("   1.3 Nauka przez zabawę"), NULL, "qrc:///help/tutorial_item_4.html"},
    { "2 Syntezatory", NULL, "qrc:///help/tutorial_item_5.html"},
    { "   2.1 Twoje pierwsze bipy", NULL, "qrc:///help/tutorial_item_6.html"},
    { QString::fromUtf8("   2.2 Parametry Syntezatorów"), NULL, "qrc:///help/tutorial_item_7.html"},
    { QString::fromUtf8("   2.3 Przełączanie Syntezatorów"), NULL, "qrc:///help/tutorial_item_8.html"},
    { QString::fromUtf8("   2.4 Czas trwania obwiedni dźwięku"), NULL, "qrc:///help/tutorial_item_9.html"},
    { "3 Sample", NULL, "qrc:///help/tutorial_item_10.html"},
    { "   3.1 Wyzwalanie Sampli", NULL, "qrc:///help/tutorial_item_11.html"},
    { "   3.2 Parametry Sampli", NULL, "qrc:///help/tutorial_item_12.html"},
    { QString::fromUtf8("   3.3 Rozciąganie Sampli"), NULL, "qrc:///help/tutorial_item_13.html"},
    { "   3.4 Opakowane Sample", NULL, "qrc:///help/tutorial_item_14.html"},
    { QString::fromUtf8("   3.5 Kawałki Sampli"), NULL, "qrc:///help/tutorial_item_15.html"},
    { QString::fromUtf8("   3.6 Sample Zewnętrzne"), NULL, "qrc:///help/tutorial_item_16.html"},
    { "   3.7 Sample Packs", NULL, "qrc:///help/tutorial_item_17.html"},
    { QString::fromUtf8("4 Losowość"), NULL, "qrc:///help/tutorial_item_18.html"},
    { "5 Konstrukcje Programistyczne", NULL, "qrc:///help/tutorial_item_19.html"},
    { "   5.1 Bloki kodu", NULL, "qrc:///help/tutorial_item_20.html"},
    { QString::fromUtf8("   5.2 Iteracja i Pętle"), NULL, "qrc:///help/tutorial_item_21.html"},
    { "   5.3 Instrukcje Warunkowe", NULL, "qrc:///help/tutorial_item_22.html"},
    { QString::fromUtf8("   5.4 Wątki"), NULL, "qrc:///help/tutorial_item_23.html"},
    { "   5.5 Funkcje", NULL, "qrc:///help/tutorial_item_24.html"},
    { "   5.6 Zmienne", NULL, "qrc:///help/tutorial_item_25.html"},
    { QString::fromUtf8("   5.7 Synchronizacja Wątków"), NULL, "qrc:///help/tutorial_item_26.html"},
    { "6 FX", NULL, "qrc:///help/tutorial_item_27.html"},
    { QString::fromUtf8("   6.1 Dodawanie Efektów"), NULL, "qrc:///help/tutorial_item_28.html"},
    { "   6.2 Efekty w praktyce", NULL, "qrc:///help/tutorial_item_29.html"},
    { "7 Kontrola", NULL, "qrc:///help/tutorial_item_30.html"},
    { QString::fromUtf8("   7.1 Kontrolowanie Uruchomionych Syntezatorów"), NULL, "qrc:///help/tutorial_item_31.html"},
    { QString::fromUtf8("   7.2 Kontrolowanie Efektów"), NULL, "qrc:///help/tutorial_item_32.html"},
    { "   7.3 Parametry Przesuwne", NULL, "qrc:///help/tutorial_item_33.html"},
    { "8 Struktury Danych", NULL, "qrc:///help/tutorial_item_34.html"},
    { "   8.1 Listy", NULL, "qrc:///help/tutorial_item_35.html"},
    { "   8.2 Akordy", NULL, "qrc:///help/tutorial_item_36.html"},
    { "   8.3 Skale", NULL, "qrc:///help/tutorial_item_37.html"},
    { QString::fromUtf8("   8.4 Pierścienie"), NULL, "qrc:///help/tutorial_item_38.html"},
    { QString::fromUtf8("   8.5 Łańcuchy Pierścieni (Ring Chains)"), NULL, "qrc:///help/tutorial_item_39.html"},
    { QString::fromUtf8("9 Kodowanie na Żywo"), NULL, "qrc:///help/tutorial_item_40.html"},
    { QString::fromUtf8("   9.1 Podstawy Kodowania na Żywo"), NULL, "qrc:///help/tutorial_item_41.html"},
    { QString::fromUtf8("   9.2 Żywe Pętle (Live Loops)"), NULL, "qrc:///help/tutorial_item_42.html"},
    { QString::fromUtf8("   9.3 Wiele Żywych Pętli"), NULL, "qrc:///help/tutorial_item_43.html"},
    { "   9.4 Cykanie", NULL, "qrc:///help/tutorial_item_44.html"},
    { QString::fromUtf8("10 Niezbędna Wiedza"), NULL, "qrc:///help/tutorial_item_45.html"},
    { QString::fromUtf8("   10.1 Korzystanie ze Skrótów Klawiszowych"), NULL, "qrc:///help/tutorial_item_46.html"},
    { QString::fromUtf8("   10.2 Ściągawka Skrótów Klawiszowych"), NULL, "qrc:///help/tutorial_item_47.html"},
    { QString::fromUtf8("   10.3 Udostępnianie"), NULL, "qrc:///help/tutorial_item_48.html"},
    { QString::fromUtf8("   10.4 Występy Na Scenie"), NULL, "qrc:///help/tutorial_item_49.html"},
    { "11 Minecraft Pi", NULL, "qrc:///help/tutorial_item_50.html"},
    { "   11.1 Podstawowe API", NULL, "qrc:///help/tutorial_item_51.html"},
    { "12 Wnioski", NULL, "qrc:///help/tutorial_item_52.html"},
    { "A Appendix A - MagPi Articles", NULL, "qrc:///help/tutorial_item_53.html"},
    { "   A.1 Tips for Sonic Pi", NULL, "qrc:///help/tutorial_item_54.html"},
    { "   A.2 Live Coding", NULL, "qrc:///help/tutorial_item_55.html"},
    { "   A.3 Coded Beats", NULL, "qrc:///help/tutorial_item_56.html"},
    { "   A.4 Synth Riffs", NULL, "qrc:///help/tutorial_item_57.html"},
    { "   A.5 Acid Bass", NULL, "qrc:///help/tutorial_item_58.html"},
    { "   A.6 Musical Minecraft", NULL, "qrc:///help/tutorial_item_59.html"},
    { "   A.7 Bizet Beats", NULL, "qrc:///help/tutorial_item_60.html"},
    { "   A.8 Become a Minecraft VJ", NULL, "qrc:///help/tutorial_item_61.html"},
    { "   A.9 Randomisation", NULL, "qrc:///help/tutorial_item_62.html"},
    { "   A.10 Control", NULL, "qrc:///help/tutorial_item_63.html"},
  };

  addHelpPage(createHelpTab(tr("Tutorial")), tutorialHelpPages, 63);

} else if (systemLocale.startsWith("fr")) {

  // language fr

  // tutorial info
  struct help_page tutorialHelpPages[] = {
    { QString::fromUtf8("1 Bienvenue à Sonic Pi"), NULL, "qrc:///help/tutorial_item_64.html"},
    { "   1.1 Codage en 'live'", NULL, "qrc:///help/tutorial_item_65.html"},
    { "   1.2 Exploration de l'interface", NULL, "qrc:///help/tutorial_item_66.html"},
    { "   1.3 Apprendre en jouant", NULL, "qrc:///help/tutorial_item_67.html"},
    { QString::fromUtf8("2 Synthés"), NULL, "qrc:///help/tutorial_item_68.html"},
    { "   2.1 Vos premiers Beeps", NULL, "qrc:///help/tutorial_item_69.html"},
    { QString::fromUtf8("   2.2 Paramètres des synthés"), NULL, "qrc:///help/tutorial_item_70.html"},
    { QString::fromUtf8("   2.3 Changement de synthés"), NULL, "qrc:///help/tutorial_item_71.html"},
    { QString::fromUtf8("   2.4 Durées avec enveloppes"), NULL, "qrc:///help/tutorial_item_72.html"},
    { QString::fromUtf8("3 Échantillons"), NULL, "qrc:///help/tutorial_item_73.html"},
    { QString::fromUtf8("   3.1 Lecture des échantillons"), NULL, "qrc:///help/tutorial_item_74.html"},
    { QString::fromUtf8("   3.2 Paramètres des échantillons"), NULL, "qrc:///help/tutorial_item_75.html"},
    { QString::fromUtf8("   3.3 Étirement des échantillons"), NULL, "qrc:///help/tutorial_item_76.html"},
    { QString::fromUtf8("   3.4 Échantillons enveloppés"), NULL, "qrc:///help/tutorial_item_77.html"},
    { QString::fromUtf8("   3.5 Échantillons partiels"), NULL, "qrc:///help/tutorial_item_78.html"},
    { QString::fromUtf8("   3.6 Échantillons externes"), NULL, "qrc:///help/tutorial_item_79.html"},
    { "   3.7 Paquets de samples", NULL, "qrc:///help/tutorial_item_80.html"},
    { "4 Randomisation", NULL, "qrc:///help/tutorial_item_81.html"},
    { "5 Structures de Programmations", NULL, "qrc:///help/tutorial_item_82.html"},
    { "   5.1 Blocs", NULL, "qrc:///help/tutorial_item_83.html"},
    { QString::fromUtf8("   5.2 Itérations et Boucles"), NULL, "qrc:///help/tutorial_item_84.html"},
    { "   5.3 Conditionnels", NULL, "qrc:///help/tutorial_item_85.html"},
    { "   5.4 Threads", NULL, "qrc:///help/tutorial_item_86.html"},
    { "   5.5 Fonctions", NULL, "qrc:///help/tutorial_item_87.html"},
    { "   5.6 Variables", NULL, "qrc:///help/tutorial_item_88.html"},
    { "   5.7 Synchronisation des Threads", NULL, "qrc:///help/tutorial_item_89.html"},
    { "6 FX (effets)", NULL, "qrc:///help/tutorial_item_90.html"},
    { "   6.1 Ajout de FX", NULL, "qrc:///help/tutorial_item_91.html"},
    { "   6.2 FX en Pratique", NULL, "qrc:///help/tutorial_item_92.html"},
    { QString::fromUtf8("7 Contrôle"), NULL, "qrc:///help/tutorial_item_93.html"},
    { QString::fromUtf8("   7.1 Contrôle des synthés en cours de jeu"), NULL, "qrc:///help/tutorial_item_94.html"},
    { QString::fromUtf8("   7.2 Contrôle des effets (FX)"), NULL, "qrc:///help/tutorial_item_95.html"},
    { QString::fromUtf8("   7.3 Paramètres glissants"), NULL, "qrc:///help/tutorial_item_96.html"},
    { QString::fromUtf8("8 Structures de données"), NULL, "qrc:///help/tutorial_item_97.html"},
    { "   8.1 Listes", NULL, "qrc:///help/tutorial_item_98.html"},
    { "   8.2 Accords", NULL, "qrc:///help/tutorial_item_99.html"},
    { "   8.3 Gammes", NULL, "qrc:///help/tutorial_item_100.html"},
    { "   8.4 Anneaux", NULL, "qrc:///help/tutorial_item_101.html"},
    { QString::fromUtf8("   8.5 Chaînes d'anneaux"), NULL, "qrc:///help/tutorial_item_102.html"},
    { "9 Codage en 'live'", NULL, "qrc:///help/tutorial_item_103.html"},
    { "   9.1 Fondamentaux du Codage en 'live'", NULL, "qrc:///help/tutorial_item_104.html"},
    { "   9.2 Boucles en 'live'", NULL, "qrc:///help/tutorial_item_105.html"},
    { "   9.3 Boucles multiples en 'live'", NULL, "qrc:///help/tutorial_item_106.html"},
    { "   9.4 Ticking", NULL, "qrc:///help/tutorial_item_107.html"},
    { "10 Connaissances essentielles", NULL, "qrc:///help/tutorial_item_108.html"},
    { "   10.1 Utilisation des raccourcis", NULL, "qrc:///help/tutorial_item_109.html"},
    { QString::fromUtf8("   10.2 Récapitulatif des raccourcis"), NULL, "qrc:///help/tutorial_item_110.html"},
    { "   10.3 Partage", NULL, "qrc:///help/tutorial_item_111.html"},
    { "   10.4 Se produire", NULL, "qrc:///help/tutorial_item_112.html"},
    { "11 Minecraft Pi", NULL, "qrc:///help/tutorial_item_113.html"},
    { "   11.1 Basique API", NULL, "qrc:///help/tutorial_item_114.html"},
    { "12 Conclusions", NULL, "qrc:///help/tutorial_item_115.html"},
    { "A Appendice A - Articles MagPi", NULL, "qrc:///help/tutorial_item_116.html"},
    { "   A.1 Conseils pour Sonic Pi", NULL, "qrc:///help/tutorial_item_117.html"},
    { "   A.2 Live Coding", NULL, "qrc:///help/tutorial_item_118.html"},
    { QString::fromUtf8("   A.3 Rythmes codés"), NULL, "qrc:///help/tutorial_item_119.html"},
    { QString::fromUtf8("   A.4 Riffs de synthés"), NULL, "qrc:///help/tutorial_item_120.html"},
    { "   A.5 Basse acide", NULL, "qrc:///help/tutorial_item_121.html"},
    { "   A.6 Minecraft musical", NULL, "qrc:///help/tutorial_item_122.html"},
    { "   A.7 Battements de Bizet", NULL, "qrc:///help/tutorial_item_123.html"},
    { "   A.8 Devenez un VJ Minecraft", NULL, "qrc:///help/tutorial_item_124.html"},
    { QString::fromUtf8("   A.9 L'aléatoire"), NULL, "qrc:///help/tutorial_item_125.html"},
    { QString::fromUtf8("   A.10 Contrôle"), NULL, "qrc:///help/tutorial_item_126.html"},
    { "   A.11 Tic tac", NULL, "qrc:///help/tutorial_item_127.html"},
  };

  addHelpPage(createHelpTab(tr("Tutorial")), tutorialHelpPages, 64);

} else if (systemLocale.startsWith("de")) {

  // language de

  // tutorial info
  struct help_page tutorialHelpPages[] = {
    { QString::fromUtf8("1 Sonic Pi begrüßt Dich!"), NULL, "qrc:///help/tutorial_item_128.html"},
    { "   1.1 Live-Coding", NULL, "qrc:///help/tutorial_item_129.html"},
    { QString::fromUtf8("   1.2 Die Programmoberfläche von Sonic Pi"), NULL, "qrc:///help/tutorial_item_130.html"},
    { "   1.3 Spielend lernen", NULL, "qrc:///help/tutorial_item_131.html"},
    { "2 Synths", NULL, "qrc:///help/tutorial_item_132.html"},
    { QString::fromUtf8("   2.1 Eure ersten Klänge"), NULL, "qrc:///help/tutorial_item_133.html"},
    { "   2.2 Synth-Parameter", NULL, "qrc:///help/tutorial_item_134.html"},
    { "   2.3 Synths wechseln", NULL, "qrc:///help/tutorial_item_135.html"},
    { QString::fromUtf8("   2.4 Dauer und Hüllkurven"), NULL, "qrc:///help/tutorial_item_136.html"},
    { "3 Samples", NULL, "qrc:///help/tutorial_item_137.html"},
    { "   3.1 Samples ansteuern", NULL, "qrc:///help/tutorial_item_138.html"},
    { "   3.2 Sample-Parameter", NULL, "qrc:///help/tutorial_item_139.html"},
    { "   3.3 Samples dehnen", NULL, "qrc:///help/tutorial_item_140.html"},
    { "   3.4 Enveloped Samples", NULL, "qrc:///help/tutorial_item_141.html"},
    { "   3.5 Teil-Samples", NULL, "qrc:///help/tutorial_item_142.html"},
    { "   3.6 Samples aus externen Quellen", NULL, "qrc:///help/tutorial_item_143.html"},
    { "4 Randomisierung", NULL, "qrc:///help/tutorial_item_144.html"},
    { "5 Programmstrukturen", NULL, "qrc:///help/tutorial_item_145.html"},
    { "   5.1 Blocks", NULL, "qrc:///help/tutorial_item_146.html"},
    { "   5.2 Iteration und Schleifen", NULL, "qrc:///help/tutorial_item_147.html"},
    { "   5.3 Bedingungen", NULL, "qrc:///help/tutorial_item_148.html"},
    { "   5.4 Threads", NULL, "qrc:///help/tutorial_item_149.html"},
    { "   5.5 Funktionen", NULL, "qrc:///help/tutorial_item_150.html"},
    { "   5.6 Variablen", NULL, "qrc:///help/tutorial_item_151.html"},
    { "   5.7 Thread-Synchronisation", NULL, "qrc:///help/tutorial_item_152.html"},
    { "6 Effekte", NULL, "qrc:///help/tutorial_item_153.html"},
    { QString::fromUtf8("   6.1 FX hinzufügen"), NULL, "qrc:///help/tutorial_item_154.html"},
    { "   6.2 FX in der Praxis", NULL, "qrc:///help/tutorial_item_155.html"},
    { "7 Steuerung", NULL, "qrc:///help/tutorial_item_156.html"},
    { "   7.1 Laufende Synths steuern", NULL, "qrc:///help/tutorial_item_157.html"},
    { "   7.2 Effekte steuern", NULL, "qrc:///help/tutorial_item_158.html"},
    { "   7.3 Gleitende Parameter", NULL, "qrc:///help/tutorial_item_159.html"},
    { "8 Datenstrukturen", NULL, "qrc:///help/tutorial_item_160.html"},
    { "   8.1 Listen", NULL, "qrc:///help/tutorial_item_161.html"},
    { "   8.2 Akkorde", NULL, "qrc:///help/tutorial_item_162.html"},
    { "   8.3 Skalen", NULL, "qrc:///help/tutorial_item_163.html"},
    { "   8.4 Ringe", NULL, "qrc:///help/tutorial_item_164.html"},
    { "9 Live-Coding", NULL, "qrc:///help/tutorial_item_165.html"},
    { "   9.1 Live-Coding: Grundlagen", NULL, "qrc:///help/tutorial_item_166.html"},
    { "   9.2 Live-Loops", NULL, "qrc:///help/tutorial_item_167.html"},
    { "   9.3 Mehrere Live-Loops", NULL, "qrc:///help/tutorial_item_168.html"},
    { "   9.4 Ticks", NULL, "qrc:///help/tutorial_item_169.html"},
    { "10 Unentbehrliche Kenntnisse", NULL, "qrc:///help/tutorial_item_170.html"},
    { QString::fromUtf8("   10.1 Tastaturkürzel"), NULL, "qrc:///help/tutorial_item_171.html"},
    { QString::fromUtf8("   10.2 Cheatsheet für Tastaturkürzel"), NULL, "qrc:///help/tutorial_item_172.html"},
    { "   10.3 Teilen", NULL, "qrc:///help/tutorial_item_173.html"},
    { "   10.4 Auftritte", NULL, "qrc:///help/tutorial_item_174.html"},
    { "11 Minecraft Pi", NULL, "qrc:///help/tutorial_item_175.html"},
    { "   11.1 Basic API", NULL, "qrc:///help/tutorial_item_176.html"},
    { "12 Abschluss", NULL, "qrc:///help/tutorial_item_177.html"},
  };

  addHelpPage(createHelpTab(tr("Tutorial")), tutorialHelpPages, 50);

} else if (systemLocale.startsWith("it")) {

  // language it

  // tutorial info
  struct help_page tutorialHelpPages[] = {
    { "1 Benvenuto in Sonic Pi", NULL, "qrc:///help/tutorial_item_178.html"},
    { "   1.1 Live Coding", NULL, "qrc:///help/tutorial_item_179.html"},
    { QString::fromUtf8("   1.2 Esploriamo l’interfaccia"), NULL, "qrc:///help/tutorial_item_180.html"},
    { "   1.3 Imparare suonando", NULL, "qrc:///help/tutorial_item_181.html"},
    { "2 Synth (Sintetizzatori)", NULL, "qrc:///help/tutorial_item_182.html"},
    { "   2.1 I tuoi primi Beep", NULL, "qrc:///help/tutorial_item_183.html"},
    { "   2.2 Parametri dei Synth", NULL, "qrc:///help/tutorial_item_184.html"},
    { "   2.3 Muoversi fra i Synth", NULL, "qrc:///help/tutorial_item_185.html"},
    { "   2.4 Durate e inviluppi", NULL, "qrc:///help/tutorial_item_186.html"},
  };

  addHelpPage(createHelpTab(tr("Tutorial")), tutorialHelpPages, 9);

} else if (systemLocale.startsWith("ja")) {

  // language ja

  // tutorial info
  struct help_page tutorialHelpPages[] = {
    { QString::fromUtf8("1 Sonic Pi へようこそ"), NULL, "qrc:///help/tutorial_item_187.html"},
    { QString::fromUtf8("   1.1 ライブコーディング"), NULL, "qrc:///help/tutorial_item_188.html"},
    { QString::fromUtf8("   1.2 インターフェースの探索"), NULL, "qrc:///help/tutorial_item_189.html"},
    { QString::fromUtf8("   1.3 遊びを通した学び"), NULL, "qrc:///help/tutorial_item_190.html"},
    { QString::fromUtf8("2 シンセ"), NULL, "qrc:///help/tutorial_item_191.html"},
    { QString::fromUtf8("   2.1 初めての音"), NULL, "qrc:///help/tutorial_item_192.html"},
    { QString::fromUtf8("   2.2 シンセのオプション"), NULL, "qrc:///help/tutorial_item_193.html"},
    { QString::fromUtf8("   2.3 シンセの切り替え"), NULL, "qrc:///help/tutorial_item_194.html"},
    { QString::fromUtf8("   2.4 エンベロープでのデュレーション"), NULL, "qrc:///help/tutorial_item_195.html"},
    { "3 Samples", NULL, "qrc:///help/tutorial_item_196.html"},
    { QString::fromUtf8("   3.1 サンプルを使う"), NULL, "qrc:///help/tutorial_item_197.html"},
    { QString::fromUtf8("   3.2 サンプル・パラメータ"), NULL, "qrc:///help/tutorial_item_198.html"},
    { QString::fromUtf8("   3.3 サンプルを引き延ばす"), NULL, "qrc:///help/tutorial_item_199.html"},
    { QString::fromUtf8("   3.4 エンベロープ・サンプル"), NULL, "qrc:///help/tutorial_item_200.html"},
    { QString::fromUtf8("   3.5 部分的なサンプル"), NULL, "qrc:///help/tutorial_item_201.html"},
    { QString::fromUtf8("   3.6 外部サンプル"), NULL, "qrc:///help/tutorial_item_202.html"},
    { QString::fromUtf8("4 ランダム化"), NULL, "qrc:///help/tutorial_item_203.html"},
    { QString::fromUtf8("5 プログラミングの構造"), NULL, "qrc:///help/tutorial_item_204.html"},
    { QString::fromUtf8("   5.1 ブロック"), NULL, "qrc:///help/tutorial_item_205.html"},
    { QString::fromUtf8("   5.2 イテレーション（反復）とループ"), NULL, "qrc:///help/tutorial_item_206.html"},
    { QString::fromUtf8("   5.3 条件文"), NULL, "qrc:///help/tutorial_item_207.html"},
    { QString::fromUtf8("   5.4 スレッド"), NULL, "qrc:///help/tutorial_item_208.html"},
    { QString::fromUtf8("   5.5 関数"), NULL, "qrc:///help/tutorial_item_209.html"},
    { QString::fromUtf8("   5.6 変数値"), NULL, "qrc:///help/tutorial_item_210.html"},
    { QString::fromUtf8("   5.7 スレッドの同期"), NULL, "qrc:///help/tutorial_item_211.html"},
    { QString::fromUtf8("6 効果"), NULL, "qrc:///help/tutorial_item_212.html"},
    { QString::fromUtf8("   6.1 エフェクトの追加"), NULL, "qrc:///help/tutorial_item_213.html"},
    { QString::fromUtf8("   6.2 エフェクトの実践"), NULL, "qrc:///help/tutorial_item_214.html"},
    { QString::fromUtf8("7 コントロール"), NULL, "qrc:///help/tutorial_item_215.html"},
    { QString::fromUtf8("   7.1 演奏中のシンセ制御"), NULL, "qrc:///help/tutorial_item_216.html"},
    { QString::fromUtf8("   7.2 エフェクトの制御"), NULL, "qrc:///help/tutorial_item_217.html"},
    { QString::fromUtf8("   7.3 オプションのスライド"), NULL, "qrc:///help/tutorial_item_218.html"},
    { QString::fromUtf8("8 データ構造"), NULL, "qrc:///help/tutorial_item_219.html"},
    { QString::fromUtf8("   8.1 リスト"), NULL, "qrc:///help/tutorial_item_220.html"},
    { QString::fromUtf8("   8.2 コード(和音)"), NULL, "qrc:///help/tutorial_item_221.html"},
    { QString::fromUtf8("   8.3 スケール(音階)"), NULL, "qrc:///help/tutorial_item_222.html"},
    { QString::fromUtf8("   8.4 リング"), NULL, "qrc:///help/tutorial_item_223.html"},
    { QString::fromUtf8("   8.5 リングのチェーン"), NULL, "qrc:///help/tutorial_item_224.html"},
    { QString::fromUtf8("9 ライブコーディング"), NULL, "qrc:///help/tutorial_item_225.html"},
    { QString::fromUtf8("   9.1 ライブコーディングの基本"), NULL, "qrc:///help/tutorial_item_226.html"},
    { QString::fromUtf8("   9.2 ライブループ"), NULL, "qrc:///help/tutorial_item_227.html"},
    { QString::fromUtf8("   9.3 マルチ・ライブループ"), NULL, "qrc:///help/tutorial_item_228.html"},
    { QString::fromUtf8("   9.4 チック"), NULL, "qrc:///help/tutorial_item_229.html"},
    { QString::fromUtf8("10 不可欠な知識"), NULL, "qrc:///help/tutorial_item_230.html"},
    { QString::fromUtf8("   10.1 ショートカットの使用"), NULL, "qrc:///help/tutorial_item_231.html"},
    { QString::fromUtf8("   10.2 ショートカット一覧表"), NULL, "qrc:///help/tutorial_item_232.html"},
    { QString::fromUtf8("   10.3 共有"), NULL, "qrc:///help/tutorial_item_233.html"},
    { QString::fromUtf8("   10.4 パフォーマンス"), NULL, "qrc:///help/tutorial_item_234.html"},
    { "11 Minecraft Pi", NULL, "qrc:///help/tutorial_item_235.html"},
    { QString::fromUtf8("   11.1 APIの基礎"), NULL, "qrc:///help/tutorial_item_236.html"},
    { QString::fromUtf8("12 おわりに"), NULL, "qrc:///help/tutorial_item_237.html"},
  };

  addHelpPage(createHelpTab(tr("Tutorial")), tutorialHelpPages, 51);

} else if (systemLocale.startsWith("es")) {

  // language es

  // tutorial info
  struct help_page tutorialHelpPages[] = {
    { "1 Bienvenido a Sonic Pi", NULL, "qrc:///help/tutorial_item_238.html"},
    { "   1.1 Live Coding", NULL, "qrc:///help/tutorial_item_239.html"},
    { "   1.2 Explorando el interfaz", NULL, "qrc:///help/tutorial_item_240.html"},
    { "   1.3 Aprender jugando", NULL, "qrc:///help/tutorial_item_241.html"},
    { "2 Sintetizadores", NULL, "qrc:///help/tutorial_item_242.html"},
    { "   2.1 Tus primeros Beeps", NULL, "qrc:///help/tutorial_item_243.html"},
    { "   2.2 Opciones Synth", NULL, "qrc:///help/tutorial_item_244.html"},
    { "   2.3 Cambiando Sintetizadores", NULL, "qrc:///help/tutorial_item_245.html"},
    { QString::fromUtf8("   2.4 Duración con Sobres"), NULL, "qrc:///help/tutorial_item_246.html"},
    { "3 Sampleos", NULL, "qrc:///help/tutorial_item_247.html"},
    { "   3.1 Disparando sampleos", NULL, "qrc:///help/tutorial_item_248.html"},
    { QString::fromUtf8("   3.2 Parámetros de sampleo"), NULL, "qrc:///help/tutorial_item_249.html"},
    { "   3.3 Estirando Samples", NULL, "qrc:///help/tutorial_item_250.html"},
    { "   3.4 Sobres para sampleos", NULL, "qrc:///help/tutorial_item_251.html"},
    { "   3.5 Sampleos parciales", NULL, "qrc:///help/tutorial_item_252.html"},
    { "4 Aleatoriedad", NULL, "qrc:///help/tutorial_item_253.html"},
    { QString::fromUtf8("5 Estructuras de Programación"), NULL, "qrc:///help/tutorial_item_254.html"},
    { "   5.1 Bloques", NULL, "qrc:///help/tutorial_item_255.html"},
    { QString::fromUtf8("   5.2 Iteración y Bucles"), NULL, "qrc:///help/tutorial_item_256.html"},
    { "   5.3 Condicionales", NULL, "qrc:///help/tutorial_item_257.html"},
    { "   5.4 Hilos", NULL, "qrc:///help/tutorial_item_258.html"},
    { "   5.5 Funciones", NULL, "qrc:///help/tutorial_item_259.html"},
    { "   5.6 Variables", NULL, "qrc:///help/tutorial_item_260.html"},
    { QString::fromUtf8("   5.7 Sincronización de hilos"), NULL, "qrc:///help/tutorial_item_261.html"},
    { "6 FX", NULL, "qrc:///help/tutorial_item_262.html"},
    { QString::fromUtf8("   6.1 Añadiendo efectos FX"), NULL, "qrc:///help/tutorial_item_263.html"},
    { QString::fromUtf8("   6.2 FX en la práctica"), NULL, "qrc:///help/tutorial_item_264.html"},
    { "7 Control", NULL, "qrc:///help/tutorial_item_265.html"},
    { QString::fromUtf8("   7.1 Controlando Sintetizadores en ejecución"), NULL, "qrc:///help/tutorial_item_266.html"},
    { "   7.2 Controlando efectos (FX)", NULL, "qrc:///help/tutorial_item_267.html"},
    { "   7.3 Opciones con Deslizadores", NULL, "qrc:///help/tutorial_item_268.html"},
    { "8 Estructuras de Datos", NULL, "qrc:///help/tutorial_item_269.html"},
    { "   8.1 Listas", NULL, "qrc:///help/tutorial_item_270.html"},
    { "   8.2 Acordes", NULL, "qrc:///help/tutorial_item_271.html"},
    { "   8.3 Escalas", NULL, "qrc:///help/tutorial_item_272.html"},
    { "   8.4 Anillos", NULL, "qrc:///help/tutorial_item_273.html"},
    { "9 Live Coding", NULL, "qrc:///help/tutorial_item_274.html"},
    { "   9.1 Fundamentos de Live Coding", NULL, "qrc:///help/tutorial_item_275.html"},
    { "   9.2 Bucles en Vivo", NULL, "qrc:///help/tutorial_item_276.html"},
    { QString::fromUtf8("   9.3 Múltiples Bucles en Vivo"), NULL, "qrc:///help/tutorial_item_277.html"},
    { "   9.4 Ticking", NULL, "qrc:///help/tutorial_item_278.html"},
    { "10 Conocimiento Esencial", NULL, "qrc:///help/tutorial_item_279.html"},
    { "   10.1 Usando atajos", NULL, "qrc:///help/tutorial_item_280.html"},
    { "   10.2 Tabla de Atajos", NULL, "qrc:///help/tutorial_item_281.html"},
    { "   10.3 Compartiendo", NULL, "qrc:///help/tutorial_item_282.html"},
    { "   10.4 Ejecutando", NULL, "qrc:///help/tutorial_item_283.html"},
    { "11 Minecraft Pi", NULL, "qrc:///help/tutorial_item_284.html"},
    { QString::fromUtf8("   11.1 API Básico"), NULL, "qrc:///help/tutorial_item_285.html"},
    { "12 Conclusiones", NULL, "qrc:///help/tutorial_item_286.html"},
  };

  addHelpPage(createHelpTab(tr("Tutorial")), tutorialHelpPages, 49);

} else {

  // language en

  // tutorial info
  struct help_page tutorialHelpPages[] = {
    { "1 Welcome to Sonic Pi", NULL, "qrc:///help/tutorial_item_287.html"},
    { "   1.1 Live Coding", NULL, "qrc:///help/tutorial_item_288.html"},
    { "   1.2 Exploring the Interface", NULL, "qrc:///help/tutorial_item_289.html"},
    { "   1.3 Learning through Play", NULL, "qrc:///help/tutorial_item_290.html"},
    { "2 Synths", NULL, "qrc:///help/tutorial_item_291.html"},
    { "   2.1 Your First Beeps", NULL, "qrc:///help/tutorial_item_292.html"},
    { "   2.2 Synth Options", NULL, "qrc:///help/tutorial_item_293.html"},
    { "   2.3 Switching Synths", NULL, "qrc:///help/tutorial_item_294.html"},
    { "   2.4 Duration with Envelopes", NULL, "qrc:///help/tutorial_item_295.html"},
    { "3 Samples", NULL, "qrc:///help/tutorial_item_296.html"},
    { "   3.1 Triggering Samples", NULL, "qrc:///help/tutorial_item_297.html"},
    { "   3.2 Sample Parameters", NULL, "qrc:///help/tutorial_item_298.html"},
    { "   3.3 Stretching Samples", NULL, "qrc:///help/tutorial_item_299.html"},
    { "   3.4 Enveloped Samples", NULL, "qrc:///help/tutorial_item_300.html"},
    { "   3.5 Partial Samples", NULL, "qrc:///help/tutorial_item_301.html"},
    { "   3.6 External Samples", NULL, "qrc:///help/tutorial_item_302.html"},
    { "   3.7 Sample Packs", NULL, "qrc:///help/tutorial_item_303.html"},
    { "4 Randomisation", NULL, "qrc:///help/tutorial_item_304.html"},
    { "5 Programming Structures", NULL, "qrc:///help/tutorial_item_305.html"},
    { "   5.1 Blocks", NULL, "qrc:///help/tutorial_item_306.html"},
    { "   5.2 Iteration and Loops", NULL, "qrc:///help/tutorial_item_307.html"},
    { "   5.3 Conditionals", NULL, "qrc:///help/tutorial_item_308.html"},
    { "   5.4 Threads", NULL, "qrc:///help/tutorial_item_309.html"},
    { "   5.5 Functions", NULL, "qrc:///help/tutorial_item_310.html"},
    { "   5.6 Variables", NULL, "qrc:///help/tutorial_item_311.html"},
    { "   5.7 Thread Synchronisation", NULL, "qrc:///help/tutorial_item_312.html"},
    { "6 FX", NULL, "qrc:///help/tutorial_item_313.html"},
    { "   6.1 Adding FX", NULL, "qrc:///help/tutorial_item_314.html"},
    { "   6.2 FX in Practice", NULL, "qrc:///help/tutorial_item_315.html"},
    { "7 Control", NULL, "qrc:///help/tutorial_item_316.html"},
    { "   7.1 Controlling Running Synths", NULL, "qrc:///help/tutorial_item_317.html"},
    { "   7.2 Controlling FX", NULL, "qrc:///help/tutorial_item_318.html"},
    { "   7.3 Sliding Options", NULL, "qrc:///help/tutorial_item_319.html"},
    { "8 Data Structures", NULL, "qrc:///help/tutorial_item_320.html"},
    { "   8.1 Lists", NULL, "qrc:///help/tutorial_item_321.html"},
    { "   8.2 Chords", NULL, "qrc:///help/tutorial_item_322.html"},
    { "   8.3 Scales", NULL, "qrc:///help/tutorial_item_323.html"},
    { "   8.4 Rings", NULL, "qrc:///help/tutorial_item_324.html"},
    { "   8.5 Ring Chains", NULL, "qrc:///help/tutorial_item_325.html"},
    { "9 Live Coding", NULL, "qrc:///help/tutorial_item_326.html"},
    { "   9.1 Live Coding Fundamentals", NULL, "qrc:///help/tutorial_item_327.html"},
    { "   9.2 Live Loops", NULL, "qrc:///help/tutorial_item_328.html"},
    { "   9.3 Multiple Live Loops", NULL, "qrc:///help/tutorial_item_329.html"},
    { "   9.4 Ticking", NULL, "qrc:///help/tutorial_item_330.html"},
    { "10 Essential Knowledge", NULL, "qrc:///help/tutorial_item_331.html"},
    { "   10.1 Using Shortcuts", NULL, "qrc:///help/tutorial_item_332.html"},
    { "   10.2 Shortcut Cheatsheet", NULL, "qrc:///help/tutorial_item_333.html"},
    { "   10.3 Sharing", NULL, "qrc:///help/tutorial_item_334.html"},
    { "   10.4 Performing", NULL, "qrc:///help/tutorial_item_335.html"},
    { "11 Minecraft Pi", NULL, "qrc:///help/tutorial_item_336.html"},
    { "   11.1 Basic API", NULL, "qrc:///help/tutorial_item_337.html"},
    { "12 Conclusions", NULL, "qrc:///help/tutorial_item_338.html"},
    { "A Appendix A - MagPi Articles", NULL, "qrc:///help/tutorial_item_339.html"},
    { "   A.1 Tips for Sonic Pi", NULL, "qrc:///help/tutorial_item_340.html"},
    { "   A.2 Live Coding", NULL, "qrc:///help/tutorial_item_341.html"},
    { "   A.3 Coded Beats", NULL, "qrc:///help/tutorial_item_342.html"},
    { "   A.4 Synth Riffs", NULL, "qrc:///help/tutorial_item_343.html"},
    { "   A.5 Acid Bass", NULL, "qrc:///help/tutorial_item_344.html"},
    { "   A.6 Musical Minecraft", NULL, "qrc:///help/tutorial_item_345.html"},
    { "   A.7 Bizet Beats", NULL, "qrc:///help/tutorial_item_346.html"},
    { "   A.8 Become a Minecraft VJ", NULL, "qrc:///help/tutorial_item_347.html"},
    { "   A.9 Randomisation", NULL, "qrc:///help/tutorial_item_348.html"},
    { "   A.10 Control", NULL, "qrc:///help/tutorial_item_349.html"},
    { "   A.11 Tick Tock", NULL, "qrc:///help/tutorial_item_350.html"},
  };

  addHelpPage(createHelpTab(tr("Tutorial")), tutorialHelpPages, 64);

}

  // examples info
  struct help_page examplesHelpPages[] = {
    { "[Apprentice] Haunted", NULL, "qrc:///help/examples_item_351.html"},
    { "[Illusionist] Jungle", NULL, "qrc:///help/examples_item_352.html"},
    { "[Illusionist] Ocean", NULL, "qrc:///help/examples_item_353.html"},
    { "[Illusionist] Filtered Dnb", NULL, "qrc:///help/examples_item_354.html"},
    { "[Illusionist] Fm Noise", NULL, "qrc:///help/examples_item_355.html"},
    { "[Illusionist] Ambient Experiment", NULL, "qrc:///help/examples_item_356.html"},
    { "[Illusionist] Chord Inversions", NULL, "qrc:///help/examples_item_357.html"},
    { "[Illusionist] Reich Phase", NULL, "qrc:///help/examples_item_358.html"},
    { "[Magician] Echo Drama", NULL, "qrc:///help/examples_item_359.html"},
    { "[Magician] Compus Beats", NULL, "qrc:///help/examples_item_360.html"},
    { "[Magician] Wob Rhyth", NULL, "qrc:///help/examples_item_361.html"},
    { "[Magician] Acid", NULL, "qrc:///help/examples_item_362.html"},
    { "[Magician] Idm Breakbeat", NULL, "qrc:///help/examples_item_363.html"},
    { "[Magician] Tron Bike", NULL, "qrc:///help/examples_item_364.html"},
    { "[Magician] Ambient", NULL, "qrc:///help/examples_item_365.html"},
    { "[Sorcerer] Monday Blues", NULL, "qrc:///help/examples_item_366.html"},
    { "[Sorcerer] Bach", NULL, "qrc:///help/examples_item_367.html"},
    { "[Sorcerer] Rerezzed", NULL, "qrc:///help/examples_item_368.html"},
    { "[Sorcerer] Driving Pulse", NULL, "qrc:///help/examples_item_369.html"},
    { "[Sorcerer] Square Skit", NULL, "qrc:///help/examples_item_370.html"},
    { "[Wizard] Time Machine", NULL, "qrc:///help/examples_item_371.html"},
    { "[Wizard] Blimp Zones", NULL, "qrc:///help/examples_item_372.html"},
    { "[Wizard] Tilburg 2", NULL, "qrc:///help/examples_item_373.html"},
    { "[Wizard] Shufflit", NULL, "qrc:///help/examples_item_374.html"},
    { "[Wizard] Blip Rhythm", NULL, "qrc:///help/examples_item_375.html"},
    { "[Algomancer] Sonic Dreams", NULL, "qrc:///help/examples_item_376.html"},
  };

  addHelpPage(createHelpTab(tr("Examples")), examplesHelpPages, 26);


  // synths info
  struct help_page synthsHelpPages[] = {
    { "Beep", "beep", "qrc:///help/synths_item_377.html"},
    { "Blade", "blade", "qrc:///help/synths_item_378.html"},
    { "Bnoise", "bnoise", "qrc:///help/synths_item_379.html"},
    { "Chipbass", "chipbass", "qrc:///help/synths_item_380.html"},
    { "Chiplead", "chiplead", "qrc:///help/synths_item_381.html"},
    { "Chipnoise", "chipnoise", "qrc:///help/synths_item_382.html"},
    { "Cnoise", "cnoise", "qrc:///help/synths_item_383.html"},
    { "Dark Ambience", "dark_ambience", "qrc:///help/synths_item_384.html"},
    { "Dpulse", "dpulse", "qrc:///help/synths_item_385.html"},
    { "Dsaw", "dsaw", "qrc:///help/synths_item_386.html"},
    { "Dtri", "dtri", "qrc:///help/synths_item_387.html"},
    { "Dull Bell", "dull_bell", "qrc:///help/synths_item_388.html"},
    { "Fm", "fm", "qrc:///help/synths_item_389.html"},
    { "Gnoise", "gnoise", "qrc:///help/synths_item_390.html"},
    { "Growl", "growl", "qrc:///help/synths_item_391.html"},
    { "Hollow", "hollow", "qrc:///help/synths_item_392.html"},
    { "Hoover", "hoover", "qrc:///help/synths_item_393.html"},
    { "Mod Beep", "mod_beep", "qrc:///help/synths_item_394.html"},
    { "Mod Dsaw", "mod_dsaw", "qrc:///help/synths_item_395.html"},
    { "Mod Fm", "mod_fm", "qrc:///help/synths_item_396.html"},
    { "Mod Pulse", "mod_pulse", "qrc:///help/synths_item_397.html"},
    { "Mod Saw", "mod_saw", "qrc:///help/synths_item_398.html"},
    { "Mod Sine", "mod_sine", "qrc:///help/synths_item_399.html"},
    { "Mod Tri", "mod_tri", "qrc:///help/synths_item_400.html"},
    { "Noise", "noise", "qrc:///help/synths_item_401.html"},
    { "Piano", "piano", "qrc:///help/synths_item_402.html"},
    { "Pluck", "pluck", "qrc:///help/synths_item_403.html"},
    { "Pnoise", "pnoise", "qrc:///help/synths_item_404.html"},
    { "Pretty Bell", "pretty_bell", "qrc:///help/synths_item_405.html"},
    { "Prophet", "prophet", "qrc:///help/synths_item_406.html"},
    { "Pulse", "pulse", "qrc:///help/synths_item_407.html"},
    { "Saw", "saw", "qrc:///help/synths_item_408.html"},
    { "Sine", "sine", "qrc:///help/synths_item_409.html"},
    { "Square", "square", "qrc:///help/synths_item_410.html"},
    { "Subpulse", "subpulse", "qrc:///help/synths_item_411.html"},
    { "Supersaw", "supersaw", "qrc:///help/synths_item_412.html"},
    { "Tb303", "tb303", "qrc:///help/synths_item_413.html"},
    { "Tri", "tri", "qrc:///help/synths_item_414.html"},
    { "Zawa", "zawa", "qrc:///help/synths_item_415.html"},
  };

  addHelpPage(createHelpTab(tr("Synths")), synthsHelpPages, 39);


  // fx info
  struct help_page fxHelpPages[] = {
    { "Band Eq", "band_eq", "qrc:///help/fx_item_416.html"},
    { "Bitcrusher", "bitcrusher", "qrc:///help/fx_item_417.html"},
    { "BPF", "bpf", "qrc:///help/fx_item_418.html"},
    { "Compressor", "compressor", "qrc:///help/fx_item_419.html"},
    { "Distortion", "distortion", "qrc:///help/fx_item_420.html"},
    { "Echo", "echo", "qrc:///help/fx_item_421.html"},
    { "Flanger", "flanger", "qrc:///help/fx_item_422.html"},
    { "Gverb", "gverb", "qrc:///help/fx_item_423.html"},
    { "HPF", "hpf", "qrc:///help/fx_item_424.html"},
    { "Ixi Techno", "ixi_techno", "qrc:///help/fx_item_425.html"},
    { "Krush", "krush", "qrc:///help/fx_item_426.html"},
    { "Level", "level", "qrc:///help/fx_item_427.html"},
    { "LPF", "lpf", "qrc:///help/fx_item_428.html"},
    { "Mono", "mono", "qrc:///help/fx_item_429.html"},
    { "NBPF", "nbpf", "qrc:///help/fx_item_430.html"},
    { "NHPF", "nhpf", "qrc:///help/fx_item_431.html"},
    { "NLPF", "nlpf", "qrc:///help/fx_item_432.html"},
    { "Normaliser", "normaliser", "qrc:///help/fx_item_433.html"},
    { "NRBPF", "nrbpf", "qrc:///help/fx_item_434.html"},
    { "NRHPF", "nrhpf", "qrc:///help/fx_item_435.html"},
    { "NRLPF", "nrlpf", "qrc:///help/fx_item_436.html"},
    { "Octaver", "octaver", "qrc:///help/fx_item_437.html"},
    { "Pan", "pan", "qrc:///help/fx_item_438.html"},
    { "Panslicer", "panslicer", "qrc:///help/fx_item_439.html"},
    { "Pitch Shift", "pitch_shift", "qrc:///help/fx_item_440.html"},
    { "RBPF", "rbpf", "qrc:///help/fx_item_441.html"},
    { "Reverb", "reverb", "qrc:///help/fx_item_442.html"},
    { "RHPF", "rhpf", "qrc:///help/fx_item_443.html"},
    { "Ring Mod", "ring_mod", "qrc:///help/fx_item_444.html"},
    { "RLPF", "rlpf", "qrc:///help/fx_item_445.html"},
    { "Slicer", "slicer", "qrc:///help/fx_item_446.html"},
    { "Tanh", "tanh", "qrc:///help/fx_item_447.html"},
    { "Vowel", "vowel", "qrc:///help/fx_item_448.html"},
    { "Whammy", "whammy", "qrc:///help/fx_item_449.html"},
    { "Wobble", "wobble", "qrc:///help/fx_item_450.html"},
  };

  addHelpPage(createHelpTab(tr("Fx")), fxHelpPages, 35);


  // samples info
  struct help_page samplesHelpPages[] = {
    { "Ambient Sounds", NULL, "qrc:///help/samples_item_451.html"},
    { "Bass Drums", NULL, "qrc:///help/samples_item_452.html"},
    { "Bass Sounds", NULL, "qrc:///help/samples_item_453.html"},
    { "Drum Sounds", NULL, "qrc:///help/samples_item_454.html"},
    { "Electric Sounds", NULL, "qrc:///help/samples_item_455.html"},
    { "Miscellaneous Sounds", NULL, "qrc:///help/samples_item_456.html"},
    { "Percussive Sounds", NULL, "qrc:///help/samples_item_457.html"},
    { "Snare Drums", NULL, "qrc:///help/samples_item_458.html"},
    { "Sounds featuring guitars", NULL, "qrc:///help/samples_item_459.html"},
    { "Sounds for Looping", NULL, "qrc:///help/samples_item_460.html"},
    { "Sounds of a Tabla Drum", NULL, "qrc:///help/samples_item_461.html"},
    { "Vinyl sounds", NULL, "qrc:///help/samples_item_462.html"},
  };

  addHelpPage(createHelpTab(tr("Samples")), samplesHelpPages, 12);


  // lang info
  struct help_page langHelpPages[] = {
    { "all_sample_names", "all_sample_names", "qrc:///help/lang_item_463.html"},
    { "assert", "assert", "qrc:///help/lang_item_464.html"},
    { "assert_equal", "assert_equal", "qrc:///help/lang_item_465.html"},
    { "at", "at", "qrc:///help/lang_item_466.html"},
    { "beat", "beat", "qrc:///help/lang_item_467.html"},
    { "block_duration", "block_duration", "qrc:///help/lang_item_468.html"},
    { "block_slept?", "block_slept?", "qrc:///help/lang_item_469.html"},
    { "bools", "bools", "qrc:///help/lang_item_470.html"},
    { "bt", "bt", "qrc:///help/lang_item_471.html"},
    { "choose", "choose", "qrc:///help/lang_item_472.html"},
    { "chord", "chord", "qrc:///help/lang_item_473.html"},
    { "chord_degree", "chord_degree", "qrc:///help/lang_item_474.html"},
    { "chord_invert", "chord_invert", "qrc:///help/lang_item_475.html"},
    { "chord_names", "chord_names", "qrc:///help/lang_item_476.html"},
    { "comment", "comment", "qrc:///help/lang_item_477.html"},
    { "control", "control", "qrc:///help/lang_item_478.html"},
    { "cue", "cue", "qrc:///help/lang_item_479.html"},
    { "current_arg_checks", "current_arg_checks", "qrc:///help/lang_item_480.html"},
    { "current_beat_duration", "current_beat_duration", "qrc:///help/lang_item_481.html"},
    { "current_bpm", "current_bpm", "qrc:///help/lang_item_482.html"},
    { "current_cent_tuning", "current_cent_tuning", "qrc:///help/lang_item_483.html"},
    { "current_debug", "current_debug", "qrc:///help/lang_item_484.html"},
    { "current_octave", "current_octave", "qrc:///help/lang_item_485.html"},
    { "current_random_seed", "current_random_seed", "qrc:///help/lang_item_486.html"},
    { "current_sample_defaults", "current_sample_defaults", "qrc:///help/lang_item_487.html"},
    { "current_sample_pack", "current_sample_pack", "qrc:///help/lang_item_488.html"},
    { "current_sched_ahead_time", "current_sched_ahead_time", "qrc:///help/lang_item_489.html"},
    { "current_synth", "current_synth", "qrc:///help/lang_item_490.html"},
    { "current_synth_defaults", "current_synth_defaults", "qrc:///help/lang_item_491.html"},
    { "current_transpose", "current_transpose", "qrc:///help/lang_item_492.html"},
    { "current_volume", "current_volume", "qrc:///help/lang_item_493.html"},
    { "dec", "dec", "qrc:///help/lang_item_494.html"},
    { "define", "define", "qrc:///help/lang_item_495.html"},
    { "defonce", "defonce", "qrc:///help/lang_item_496.html"},
    { "degree", "degree", "qrc:///help/lang_item_497.html"},
    { "density", "density", "qrc:///help/lang_item_498.html"},
    { "dice", "dice", "qrc:///help/lang_item_499.html"},
    { "doubles", "doubles", "qrc:///help/lang_item_500.html"},
    { "factor?", "factor?", "qrc:///help/lang_item_501.html"},
    { "fx_names", "fx_names", "qrc:///help/lang_item_502.html"},
    { "halves", "halves", "qrc:///help/lang_item_503.html"},
    { "hz_to_midi", "hz_to_midi", "qrc:///help/lang_item_504.html"},
    { "in_thread", "in_thread", "qrc:///help/lang_item_505.html"},
    { "inc", "inc", "qrc:///help/lang_item_506.html"},
    { "inspect", "inspect", "qrc:///help/lang_item_507.html"},
    { "kill", "kill", "qrc:///help/lang_item_508.html"},
    { "knit", "knit", "qrc:///help/lang_item_509.html"},
    { "line", "line", "qrc:///help/lang_item_510.html"},
    { "live_loop", "live_loop", "qrc:///help/lang_item_511.html"},
    { "load_buffer", "load_buffer", "qrc:///help/lang_item_512.html"},
    { "load_example", "load_example", "qrc:///help/lang_item_513.html"},
    { "load_sample", "load_sample", "qrc:///help/lang_item_514.html"},
    { "load_samples", "load_samples", "qrc:///help/lang_item_515.html"},
    { "load_synthdefs", "load_synthdefs", "qrc:///help/lang_item_516.html"},
    { "look", "look", "qrc:///help/lang_item_517.html"},
    { "mc_block_id", "mc_block_id", "qrc:///help/lang_item_518.html"},
    { "mc_block_ids", "mc_block_ids", "qrc:///help/lang_item_519.html"},
    { "mc_block_name", "mc_block_name", "qrc:///help/lang_item_520.html"},
    { "mc_block_names", "mc_block_names", "qrc:///help/lang_item_521.html"},
    { "mc_camera_fixed", "mc_camera_fixed", "qrc:///help/lang_item_522.html"},
    { "mc_camera_normal", "mc_camera_normal", "qrc:///help/lang_item_523.html"},
    { "mc_camera_set_location", "mc_camera_set_location", "qrc:///help/lang_item_524.html"},
    { "mc_camera_third_person", "mc_camera_third_person", "qrc:///help/lang_item_525.html"},
    { "mc_chat_post", "mc_chat_post", "qrc:///help/lang_item_526.html"},
    { "mc_checkpoint_restore", "mc_checkpoint_restore", "qrc:///help/lang_item_527.html"},
    { "mc_checkpoint_save", "mc_checkpoint_save", "qrc:///help/lang_item_528.html"},
    { "mc_get_block", "mc_get_block", "qrc:///help/lang_item_529.html"},
    { "mc_get_height", "mc_get_height", "qrc:///help/lang_item_530.html"},
    { "mc_get_pos", "mc_get_pos", "qrc:///help/lang_item_531.html"},
    { "mc_get_tile", "mc_get_tile", "qrc:///help/lang_item_532.html"},
    { "mc_ground_height", "mc_ground_height", "qrc:///help/lang_item_533.html"},
    { "mc_location", "mc_location", "qrc:///help/lang_item_534.html"},
    { "mc_message", "mc_message", "qrc:///help/lang_item_535.html"},
    { "mc_set_area", "mc_set_area", "qrc:///help/lang_item_536.html"},
    { "mc_set_block", "mc_set_block", "qrc:///help/lang_item_537.html"},
    { "mc_set_pos", "mc_set_pos", "qrc:///help/lang_item_538.html"},
    { "mc_set_tile", "mc_set_tile", "qrc:///help/lang_item_539.html"},
    { "mc_surface_teleport", "mc_surface_teleport", "qrc:///help/lang_item_540.html"},
    { "mc_teleport", "mc_teleport", "qrc:///help/lang_item_541.html"},
    { "midi_notes", "midi_notes", "qrc:///help/lang_item_542.html"},
    { "midi_to_hz", "midi_to_hz", "qrc:///help/lang_item_543.html"},
    { "ndefine", "ndefine", "qrc:///help/lang_item_544.html"},
    { "note", "note", "qrc:///help/lang_item_545.html"},
    { "note_info", "note_info", "qrc:///help/lang_item_546.html"},
    { "note_range", "note_range", "qrc:///help/lang_item_547.html"},
    { "octs", "octs", "qrc:///help/lang_item_548.html"},
    { "on", "on", "qrc:///help/lang_item_549.html"},
    { "one_in", "one_in", "qrc:///help/lang_item_550.html"},
    { "pick", "pick", "qrc:///help/lang_item_551.html"},
    { "pitch_to_ratio", "pitch_to_ratio", "qrc:///help/lang_item_552.html"},
    { "play", "play", "qrc:///help/lang_item_553.html"},
    { "play_chord", "play_chord", "qrc:///help/lang_item_554.html"},
    { "play_pattern", "play_pattern", "qrc:///help/lang_item_555.html"},
    { "play_pattern_timed", "play_pattern_timed", "qrc:///help/lang_item_556.html"},
    { "print", "print", "qrc:///help/lang_item_557.html"},
    { "puts", "puts", "qrc:///help/lang_item_558.html"},
    { "quantise", "quantise", "qrc:///help/lang_item_559.html"},
    { "ramp", "ramp", "qrc:///help/lang_item_560.html"},
    { "rand", "rand", "qrc:///help/lang_item_561.html"},
    { "rand_back", "rand_back", "qrc:///help/lang_item_562.html"},
    { "rand_i", "rand_i", "qrc:///help/lang_item_563.html"},
    { "rand_reset", "rand_reset", "qrc:///help/lang_item_564.html"},
    { "rand_skip", "rand_skip", "qrc:///help/lang_item_565.html"},
    { "range", "range", "qrc:///help/lang_item_566.html"},
    { "ratio_to_pitch", "ratio_to_pitch", "qrc:///help/lang_item_567.html"},
    { "rdist", "rdist", "qrc:///help/lang_item_568.html"},
    { "reset_mixer!", "reset_mixer!", "qrc:///help/lang_item_569.html"},
    { "rest?", "rest?", "qrc:///help/lang_item_570.html"},
    { "ring", "ring", "qrc:///help/lang_item_571.html"},
    { "rrand", "rrand", "qrc:///help/lang_item_572.html"},
    { "rrand_i", "rrand_i", "qrc:///help/lang_item_573.html"},
    { "rt", "rt", "qrc:///help/lang_item_574.html"},
    { "sample", "sample", "qrc:///help/lang_item_575.html"},
    { "sample_buffer", "sample_buffer", "qrc:///help/lang_item_576.html"},
    { "sample_duration", "sample_duration", "qrc:///help/lang_item_577.html"},
    { "sample_free", "sample_free", "qrc:///help/lang_item_578.html"},
    { "sample_free_all", "sample_free_all", "qrc:///help/lang_item_579.html"},
    { "sample_groups", "sample_groups", "qrc:///help/lang_item_580.html"},
    { "sample_info", "sample_info", "qrc:///help/lang_item_581.html"},
    { "sample_loaded?", "sample_loaded?", "qrc:///help/lang_item_582.html"},
    { "sample_names", "sample_names", "qrc:///help/lang_item_583.html"},
    { "sample_paths", "sample_paths", "qrc:///help/lang_item_584.html"},
    { "scale", "scale", "qrc:///help/lang_item_585.html"},
    { "scale_names", "scale_names", "qrc:///help/lang_item_586.html"},
    { "set_cent_tuning!", "set_cent_tuning!", "qrc:///help/lang_item_587.html"},
    { "set_control_delta!", "set_control_delta!", "qrc:///help/lang_item_588.html"},
    { "set_mixer_control!", "set_mixer_control!", "qrc:///help/lang_item_589.html"},
    { "set_sched_ahead_time!", "set_sched_ahead_time!", "qrc:///help/lang_item_590.html"},
    { "set_volume!", "set_volume!", "qrc:///help/lang_item_591.html"},
    { "shuffle", "shuffle", "qrc:///help/lang_item_592.html"},
    { "sleep", "sleep", "qrc:///help/lang_item_593.html"},
    { "spark", "spark", "qrc:///help/lang_item_594.html"},
    { "spark_graph", "spark_graph", "qrc:///help/lang_item_595.html"},
    { "spread", "spread", "qrc:///help/lang_item_596.html"},
    { "status", "status", "qrc:///help/lang_item_597.html"},
    { "stop", "stop", "qrc:///help/lang_item_598.html"},
    { "stretch", "stretch", "qrc:///help/lang_item_599.html"},
    { "sync", "sync", "qrc:///help/lang_item_600.html"},
    { "sync_bpm", "sync_bpm", "qrc:///help/lang_item_601.html"},
    { "synth", "synth", "qrc:///help/lang_item_602.html"},
    { "synth_names", "synth_names", "qrc:///help/lang_item_603.html"},
    { "tick", "tick", "qrc:///help/lang_item_604.html"},
    { "tick_reset", "tick_reset", "qrc:///help/lang_item_605.html"},
    { "tick_reset_all", "tick_reset_all", "qrc:///help/lang_item_606.html"},
    { "tick_set", "tick_set", "qrc:///help/lang_item_607.html"},
    { "uncomment", "uncomment", "qrc:///help/lang_item_608.html"},
    { "use_arg_bpm_scaling", "use_arg_bpm_scaling", "qrc:///help/lang_item_609.html"},
    { "use_arg_checks", "use_arg_checks", "qrc:///help/lang_item_610.html"},
    { "use_bpm", "use_bpm", "qrc:///help/lang_item_611.html"},
    { "use_bpm_mul", "use_bpm_mul", "qrc:///help/lang_item_612.html"},
    { "use_cent_tuning", "use_cent_tuning", "qrc:///help/lang_item_613.html"},
    { "use_cue_logging", "use_cue_logging", "qrc:///help/lang_item_614.html"},
    { "use_debug", "use_debug", "qrc:///help/lang_item_615.html"},
    { "use_merged_sample_defaults", "use_merged_sample_defaults", "qrc:///help/lang_item_616.html"},
    { "use_merged_synth_defaults", "use_merged_synth_defaults", "qrc:///help/lang_item_617.html"},
    { "use_octave", "use_octave", "qrc:///help/lang_item_618.html"},
    { "use_random_seed", "use_random_seed", "qrc:///help/lang_item_619.html"},
    { "use_sample_bpm", "use_sample_bpm", "qrc:///help/lang_item_620.html"},
    { "use_sample_defaults", "use_sample_defaults", "qrc:///help/lang_item_621.html"},
    { "use_sample_pack", "use_sample_pack", "qrc:///help/lang_item_622.html"},
    { "use_synth", "use_synth", "qrc:///help/lang_item_623.html"},
    { "use_synth_defaults", "use_synth_defaults", "qrc:///help/lang_item_624.html"},
    { "use_timing_guarantees", "use_timing_guarantees", "qrc:///help/lang_item_625.html"},
    { "use_transpose", "use_transpose", "qrc:///help/lang_item_626.html"},
    { "use_tuning", "use_tuning", "qrc:///help/lang_item_627.html"},
    { "vector", "vector", "qrc:///help/lang_item_628.html"},
    { "version", "version", "qrc:///help/lang_item_629.html"},
    { "vt", "vt", "qrc:///help/lang_item_630.html"},
    { "wait", "wait", "qrc:///help/lang_item_631.html"},
    { "with_arg_bpm_scaling", "with_arg_bpm_scaling", "qrc:///help/lang_item_632.html"},
    { "with_arg_checks", "with_arg_checks", "qrc:///help/lang_item_633.html"},
    { "with_bpm", "with_bpm", "qrc:///help/lang_item_634.html"},
    { "with_bpm_mul", "with_bpm_mul", "qrc:///help/lang_item_635.html"},
    { "with_cent_tuning", "with_cent_tuning", "qrc:///help/lang_item_636.html"},
    { "with_cue_logging", "with_cue_logging", "qrc:///help/lang_item_637.html"},
    { "with_debug", "with_debug", "qrc:///help/lang_item_638.html"},
    { "with_fx", "with_fx", "qrc:///help/lang_item_639.html"},
    { "with_merged_sample_defaults", "with_merged_sample_defaults", "qrc:///help/lang_item_640.html"},
    { "with_merged_synth_defaults", "with_merged_synth_defaults", "qrc:///help/lang_item_641.html"},
    { "with_octave", "with_octave", "qrc:///help/lang_item_642.html"},
    { "with_random_seed", "with_random_seed", "qrc:///help/lang_item_643.html"},
    { "with_sample_bpm", "with_sample_bpm", "qrc:///help/lang_item_644.html"},
    { "with_sample_defaults", "with_sample_defaults", "qrc:///help/lang_item_645.html"},
    { "with_sample_pack", "with_sample_pack", "qrc:///help/lang_item_646.html"},
    { "with_synth", "with_synth", "qrc:///help/lang_item_647.html"},
    { "with_synth_defaults", "with_synth_defaults", "qrc:///help/lang_item_648.html"},
    { "with_timing_guarantees", "with_timing_guarantees", "qrc:///help/lang_item_649.html"},
    { "with_transpose", "with_transpose", "qrc:///help/lang_item_650.html"},
    { "with_tuning", "with_tuning", "qrc:///help/lang_item_651.html"},
  };

  addHelpPage(createHelpTab(tr("Lang")), langHelpPages, 189);

  // FX arguments for autocompletion
  QStringList fxtmp;
  // fx :bitcrusher
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "sample_rate:" << "bits:" << "cutoff:" ;
  autocomplete->addFXArgs(":bitcrusher", fxtmp);

  // fx :krush
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "gain:" << "cutoff:" << "res:" ;
  autocomplete->addFXArgs(":krush", fxtmp);

  // fx :reverb
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "room:" << "damp:" ;
  autocomplete->addFXArgs(":reverb", fxtmp);

  // fx :gverb
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "spread:" << "damp:" << "pre_damp:" << "dry:" << "room:" << "release:" << "ref_level:" << "tail_level:" ;
  autocomplete->addFXArgs(":gverb", fxtmp);

  // fx :level
  fxtmp.clear(); fxtmp << "amp:" ;
  autocomplete->addFXArgs(":level", fxtmp);

  // fx :mono
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "mix:" ;
  autocomplete->addFXArgs(":mono", fxtmp);

  // fx :echo
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "phase:" << "decay:" << "max_phase:" ;
  autocomplete->addFXArgs(":echo", fxtmp);

  // fx :slicer
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "phase:" << "amp_min:" << "amp_max:" << "pulse_width:" << "phase_offset:" << "wave:" << "invert_wave:" << "probability:" << "prob_pos:" << "seed:" << "smooth:" << "smooth_up:" << "smooth_down:" ;
  autocomplete->addFXArgs(":slicer", fxtmp);

  // fx :panslicer
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "phase:" << "pan_min:" << "pan_max:" << "pulse_width:" << "phase_offset:" << "wave:" << "invert_wave:" << "probability:" << "prob_pos:" << "seed:" << "smooth:" << "smooth_up:" << "smooth_down:" ;
  autocomplete->addFXArgs(":panslicer", fxtmp);

  // fx :wobble
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "phase:" << "cutoff_min:" << "cutoff_max:" << "res:" << "phase_offset:" << "wave:" << "invert_wave:" << "pulse_width:" << "filter:" << "probability:" << "prob_pos:" << "seed:" << "smooth:" << "smooth_up:" << "smooth_down:" ;
  autocomplete->addFXArgs(":wobble", fxtmp);

  // fx :ixi_techno
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "phase:" << "phase_offset:" << "cutoff_min:" << "cutoff_max:" << "res:" ;
  autocomplete->addFXArgs(":ixi_techno", fxtmp);

  // fx :compressor
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "threshold:" << "clamp_time:" << "slope_above:" << "slope_below:" << "relax_time:" ;
  autocomplete->addFXArgs(":compressor", fxtmp);

  // fx :whammy
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "transpose:" << "max_delay_time:" << "deltime:" << "grainsize:" ;
  autocomplete->addFXArgs(":whammy", fxtmp);

  // fx :rlpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "cutoff:" << "res:" ;
  autocomplete->addFXArgs(":rlpf", fxtmp);

  // fx :nrlpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "cutoff:" << "res:" ;
  autocomplete->addFXArgs(":nrlpf", fxtmp);

  // fx :rhpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "cutoff:" << "res:" ;
  autocomplete->addFXArgs(":rhpf", fxtmp);

  // fx :nrhpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "cutoff:" << "res:" ;
  autocomplete->addFXArgs(":nrhpf", fxtmp);

  // fx :hpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "cutoff:" ;
  autocomplete->addFXArgs(":hpf", fxtmp);

  // fx :nhpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "cutoff:" ;
  autocomplete->addFXArgs(":nhpf", fxtmp);

  // fx :lpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "cutoff:" ;
  autocomplete->addFXArgs(":lpf", fxtmp);

  // fx :nlpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "cutoff:" ;
  autocomplete->addFXArgs(":nlpf", fxtmp);

  // fx :normaliser
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "level:" ;
  autocomplete->addFXArgs(":normaliser", fxtmp);

  // fx :distortion
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "distort:" ;
  autocomplete->addFXArgs(":distortion", fxtmp);

  // fx :pan
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "pan:" ;
  autocomplete->addFXArgs(":pan", fxtmp);

  // fx :bpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "centre:" << "res:" ;
  autocomplete->addFXArgs(":bpf", fxtmp);

  // fx :nbpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "centre:" << "res:" ;
  autocomplete->addFXArgs(":nbpf", fxtmp);

  // fx :rbpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "centre:" << "res:" ;
  autocomplete->addFXArgs(":rbpf", fxtmp);

  // fx :nrbpf
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "centre:" << "res:" ;
  autocomplete->addFXArgs(":nrbpf", fxtmp);

  // fx :band_eq
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "freq:" << "res:" << "db:" ;
  autocomplete->addFXArgs(":band_eq", fxtmp);

  // fx :tanh
  fxtmp.clear(); fxtmp << "amp:" << "pre_amp:" << "mix:" << "krunch:" ;
  autocomplete->addFXArgs(":tanh", fxtmp);

  // fx :pitch_shift
  fxtmp.clear(); fxtmp << "amp:" << "pre_amp:" << "mix:" << "window_size:" << "pitch:" << "pitch_dis:" << "time_dis:" ;
  autocomplete->addFXArgs(":pitch_shift", fxtmp);

  // fx :ring_mod
  fxtmp.clear(); fxtmp << "freq:" << "amp:" << "mix:" << "pre_amp:" << "mod_amp:" ;
  autocomplete->addFXArgs(":ring_mod", fxtmp);

  // fx :octaver
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "super_amp:" << "sub_amp:" << "subsub_amp:" ;
  autocomplete->addFXArgs(":octaver", fxtmp);

  // fx :vowel
  fxtmp.clear(); fxtmp << "amp:" << "pre_amp:" << "vowel_sound:" << "voice:" ;
  autocomplete->addFXArgs(":vowel", fxtmp);

  // fx :flanger
  fxtmp.clear(); fxtmp << "amp:" << "mix:" << "pre_amp:" << "phase:" << "phase_offset:" << "wave:" << "invert_wave:" << "stereo_invert_wave:" << "delay:" << "max_delay:" << "depth:" << "decay:" << "feedback:" << "invert_flange:" ;
  autocomplete->addFXArgs(":flanger", fxtmp);

  // synth :dull_bell
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" ;
  autocomplete->addSynthArgs(":dull_bell", fxtmp);

  // synth :pretty_bell
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" ;
  autocomplete->addSynthArgs(":pretty_bell", fxtmp);

  // synth :beep
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" ;
  autocomplete->addSynthArgs(":beep", fxtmp);

  // synth :sine
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" ;
  autocomplete->addSynthArgs(":sine", fxtmp);

  // synth :saw
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" ;
  autocomplete->addSynthArgs(":saw", fxtmp);

  // synth :pulse
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "pulse_width:" ;
  autocomplete->addSynthArgs(":pulse", fxtmp);

  // synth :subpulse
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "pulse_width:" << "sub_amp:" << "sub_detune:" ;
  autocomplete->addSynthArgs(":subpulse", fxtmp);

  // synth :square
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" ;
  autocomplete->addSynthArgs(":square", fxtmp);

  // synth :tri
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "pulse_width:" ;
  autocomplete->addSynthArgs(":tri", fxtmp);

  // synth :dsaw
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "detune:" ;
  autocomplete->addSynthArgs(":dsaw", fxtmp);

  // synth :dpulse
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "detune:" << "pulse_width:" << "dpulse_width:" ;
  autocomplete->addSynthArgs(":dpulse", fxtmp);

  // synth :dtri
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "detune:" ;
  autocomplete->addSynthArgs(":dtri", fxtmp);

  // synth :fm
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "divisor:" << "depth:" ;
  autocomplete->addSynthArgs(":fm", fxtmp);

  // synth :mod_fm
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "divisor:" << "depth:" << "mod_phase:" << "mod_range:" << "mod_pulse_width:" << "mod_phase_offset:" << "mod_invert_wave:" << "mod_wave:" ;
  autocomplete->addSynthArgs(":mod_fm", fxtmp);

  // synth :mod_saw
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "mod_phase:" << "mod_range:" << "mod_pulse_width:" << "mod_phase_offset:" << "mod_invert_wave:" << "mod_wave:" ;
  autocomplete->addSynthArgs(":mod_saw", fxtmp);

  // synth :mod_dsaw
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "mod_phase:" << "mod_range:" << "mod_pulse_width:" << "mod_phase_offset:" << "mod_invert_wave:" << "mod_wave:" << "detune:" ;
  autocomplete->addSynthArgs(":mod_dsaw", fxtmp);

  // synth :mod_sine
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "mod_phase:" << "mod_range:" << "mod_pulse_width:" << "mod_phase_offset:" << "mod_invert_wave:" << "mod_wave:" ;
  autocomplete->addSynthArgs(":mod_sine", fxtmp);

  // synth :mod_beep
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "mod_phase:" << "mod_range:" << "mod_pulse_width:" << "mod_phase_offset:" << "mod_invert_wave:" << "mod_wave:" ;
  autocomplete->addSynthArgs(":mod_beep", fxtmp);

  // synth :mod_tri
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "mod_phase:" << "mod_range:" << "mod_pulse_width:" << "mod_phase_offset:" << "mod_invert_wave:" << "mod_wave:" ;
  autocomplete->addSynthArgs(":mod_tri", fxtmp);

  // synth :mod_pulse
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "mod_phase:" << "mod_range:" << "mod_pulse_width:" << "mod_phase_offset:" << "mod_invert_wave:" << "mod_wave:" << "pulse_width:" ;
  autocomplete->addSynthArgs(":mod_pulse", fxtmp);

  // synth :chiplead
  fxtmp.clear(); fxtmp << "note:" << "note_resolution:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "width:" ;
  autocomplete->addSynthArgs(":chiplead", fxtmp);

  // synth :chipbass
  fxtmp.clear(); fxtmp << "note:" << "note_resolution:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" ;
  autocomplete->addSynthArgs(":chipbass", fxtmp);

  // synth :tb303
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "cutoff_min:" << "cutoff_attack:" << "cutoff_decay:" << "cutoff_sustain:" << "cutoff_release:" << "cutoff_attack_level:" << "cutoff_decay_level:" << "cutoff_sustain_level:" << "res:" << "wave:" << "pulse_width:" ;
  autocomplete->addSynthArgs(":tb303", fxtmp);

  // synth :supersaw
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" ;
  autocomplete->addSynthArgs(":supersaw", fxtmp);

  // synth :hoover
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" ;
  autocomplete->addSynthArgs(":hoover", fxtmp);

  // synth :prophet
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" ;
  autocomplete->addSynthArgs(":prophet", fxtmp);

  // synth :zawa
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "cutoff:" << "res:" << "phase:" << "phase_offset:" << "wave:" << "invert_wave:" << "range:" << "disable_wave:" << "pulse_width:" ;
  autocomplete->addSynthArgs(":zawa", fxtmp);

  // synth :dark_ambience
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" << "detune1:" << "detune2:" << "noise:" << "ring:" << "room:" << "reverb_time:" ;
  autocomplete->addSynthArgs(":dark_ambience", fxtmp);

  // synth :growl
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" ;
  autocomplete->addSynthArgs(":growl", fxtmp);

  // synth :hollow
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" << "noise:" << "norm:" ;
  autocomplete->addSynthArgs(":hollow", fxtmp);

  // synth :mono_player
  fxtmp.clear(); fxtmp << "amp:" << "pre_amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "lpf:" << "lpf_attack:" << "lpf_decay:" << "lpf_sustain:" << "lpf_release:" << "lpf_init_level:" << "lpf_attack_level:" << "lpf_decay_level:" << "lpf_sustain_level:" << "lpf_release_level:" << "lpf_env_curve:" << "lpf_min:" << "hpf:" << "hpf_attack:" << "hpf_sustain:" << "hpf_decay:" << "hpf_release:" << "hpf_init_level:" << "hpf_attack_level:" << "hpf_decay_level:" << "hpf_sustain_level:" << "hpf_release_level:" << "hpf_env_curve:" << "hpf_max:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "rate:" << "start:" << "finish:" << "norm:" << "pitch:" << "window_size:" << "pitch_dis:" << "time_dis:" << "compress:" << "threshold:" << "clamp_time:" << "slope_above:" << "slope_below:" << "relax_time:" ;
  autocomplete->addSynthArgs(":mono_player", fxtmp);

  // synth :stereo_player
  fxtmp.clear(); fxtmp << "amp:" << "pre_amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "lpf:" << "lpf_attack:" << "lpf_decay:" << "lpf_sustain:" << "lpf_release:" << "lpf_init_level:" << "lpf_attack_level:" << "lpf_decay_level:" << "lpf_sustain_level:" << "lpf_release_level:" << "lpf_env_curve:" << "lpf_min:" << "hpf:" << "hpf_attack:" << "hpf_sustain:" << "hpf_decay:" << "hpf_release:" << "hpf_init_level:" << "hpf_attack_level:" << "hpf_decay_level:" << "hpf_sustain_level:" << "hpf_release_level:" << "hpf_env_curve:" << "hpf_max:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "rate:" << "start:" << "finish:" << "norm:" << "pitch:" << "window_size:" << "pitch_dis:" << "time_dis:" << "compress:" << "threshold:" << "clamp_time:" << "slope_above:" << "slope_below:" << "relax_time:" ;
  autocomplete->addSynthArgs(":stereo_player", fxtmp);

  // synth :blade
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "vibrato_rate:" << "vibrato_depth:" << "vibrato_delay:" << "vibrato_onset:" ;
  autocomplete->addSynthArgs(":blade", fxtmp);

  // synth :piano
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "vel:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "hard:" << "stereo_width:" ;
  autocomplete->addSynthArgs(":piano", fxtmp);

  // synth :pluck
  fxtmp.clear(); fxtmp << "note:" << "amp:" << "pan:" << "attack:" << "sustain:" << "release:" << "attack_level:" << "decay:" << "decay_level:" << "sustain_level:" << "noise_amp:" << "max_delay_time:" << "pluck_decay:" << "coef:" ;
  autocomplete->addSynthArgs(":pluck", fxtmp);

  // synth :sound_in
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "input:" ;
  autocomplete->addSynthArgs(":sound_in", fxtmp);

  // synth :sound_in_stereo
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "input:" ;
  autocomplete->addSynthArgs(":sound_in_stereo", fxtmp);

  // synth :noise
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" ;
  autocomplete->addSynthArgs(":noise", fxtmp);

  // synth :pnoise
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" ;
  autocomplete->addSynthArgs(":pnoise", fxtmp);

  // synth :bnoise
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" ;
  autocomplete->addSynthArgs(":bnoise", fxtmp);

  // synth :gnoise
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" ;
  autocomplete->addSynthArgs(":gnoise", fxtmp);

  // synth :cnoise
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "cutoff:" << "res:" ;
  autocomplete->addSynthArgs(":cnoise", fxtmp);

  // synth :chipnoise
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "attack:" << "decay:" << "sustain:" << "release:" << "attack_level:" << "decay_level:" << "sustain_level:" << "env_curve:" << "freq_band:" ;
  autocomplete->addSynthArgs(":chipnoise", fxtmp);

  // synth :basic_mono_player
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "rate:" << "lpf:" << "hpf:" ;
  autocomplete->addSynthArgs(":basic_mono_player", fxtmp);

  // synth :basic_stereo_player
  fxtmp.clear(); fxtmp << "amp:" << "pan:" << "rate:" << "lpf:" << "hpf:" ;
  autocomplete->addSynthArgs(":basic_stereo_player", fxtmp);

  // synth :basic_mixer
  fxtmp.clear(); fxtmp << "amp:" ;
  autocomplete->addSynthArgs(":basic_mixer", fxtmp);

  // synth :main_mixer
  fxtmp.clear(); fxtmp << "amp:" << "pre_amp:" << "hpf:" << "lpf:" << "hpf_bypass:" << "lpf_bypass:" << "force_mono:" << "invert_stereo:" << "limiter_bypass:" << "leak_dc_bypass:" ;
  autocomplete->addSynthArgs(":main_mixer", fxtmp);

}
