1.2 Explorando el interfaz

# El interfaz de Sonic Pi

Sonic Pi tiene un sencillo interfaz para codificar música.
Explorémoslo por un momento.

![Sonic Pi Interface](../images/tutorial/GUI.png)


* *A* - Controles de Ejecución
* *B* - Controles de edición
* *C* - Info y ayuda
* *D* - Editor de código 
* *E* - Panel de Preferencias
* *F* - Visor de bitácora
* *G* - Sistema de ayuda


## A. Controles de Ejecución

Estos botones rosados son los principales controles para comenzar y
parar sonidos. Está el botón de 'Ejecutar' para correr el código en el
editor y 'Parar' para parar todo código en Ejecución en el editor, 
'Guardar' para guardar el código a un archivo externo y 'Grabar' para
crear una grabación (archivo WAV) de los sonidos ejecutándose.

## B. Controles de edición

Estos botones anaranjados te permiten manipular el editor del código.
Los botones *Tamaño+* y *Tamaño-* te permiten cambiar el tamaño del texto.
El botón *Alinear*  hará que tu código este más claro y profesional.

## C. Info y ayuda

Estos botones azules te dan acceso a información, ayuda y preferencias.
El botón *Info* abre la ventana informativa, la cual contiene información
del propio programa Sonic Pi - el equipo base, historia, contribuyentes y
la comunidad. El botón de *Ayuda* cambia entre el sistema de ayuda y el
botón *Preferencias* activa la ventana de preferencias, la cual te permite
controlar algunos parametros básicos del sistema.

## D. Editor de código

Esta es el área donde escribirás tu código y compndrás/ejecutarás
música. Es un sencillo editor de texto donde puedes escribir, borrar,
cortar, pegar, etc. Piensa que es una versión simplificada de Word o
Google Docs.

El editor colorea las palabras utomáticamente, basado en su significado
para el código.Al principio, esto puede parecer extraño, pero pronto lo
encontrarás muy útil. Por ejemplo, sabrás que algo es un número, porque
es de color azul.

## E. Panel de Preferencias

Sonic Pi permite cambiar ciertos parámetros, accesibles a través del botón
*preferencias* . Este botón cambia la visibilidad del panel de preferencias,
el cual incluye un número de opciones a ser cambiadas. Ejemplo de ellas son
el forzar el modo mono, invertir el estéreo, cambiar a vista/no vista de la
bitácora, mando de volumen y un selector de audio para la Raspberry  Pi

## F. Visor de la bitácora

Cuando ejecutas un código, la bitácora muestra información de lo que está
haciendo el programa. Predeterminado está el que veas un mensaje por cada
sonido que crees con el tiempo exacto al que fue disparado el sonido. Esto
es muy útil para depurar código y entender qué es lo que está haciendo.

## G. Sistema de ayuda

Finalmente, una de las partes más importantes del interface de Sonic Pi
es el sistema de ayuda que aparece en la parte baja de la ventana.
Esta puede ser activada o desactivada al apretar el botón azul «ayuda».
El sistema de ayuda contiene información de todos los aspectos de 
Sonic Pi incluídos en este tutorial, listado de sintetizadores disponibles, 
sampleos, ejemplos, FX y una lista de todas las funciones que Sonic Pi
provee para codificar música.
