2.1 Twoje pierwsze bipy

# Twoje pierwsze bipy

Spójrz na poniższy kod:

```
play 70
```

To jest miejsce, w którym wszystko się zaczyna. Śmiało, skopiuj powyższy kod 
i wklej go do edytora kodu na górze aplikacji (duża biała przestrzeń 
tuż pod przyciskiem *Run*). Kiedy już to zrobisz, naciśnij przycisk Run...

## Bip!

A teraz naciśnij przycisk jescze raz. I jeszcze raz. *I jeszcze raz...*

Łał, szaleństwo. Jestem pewien, że możesz tak przez cały dzień. Ale poczekaj. 
Zanim zatracisz się w pętli nieskończonych bipów, spróbuj zmienić liczbę: 

```
play 75
```

Słyszysz różnicę? OK, teraz spróbuj mniejszej liczby: 

```
play 60
```

Zauważ, że mniejsze liczby powodują bipy o niższym tonie a większe liczby 
powodują bipy o wyższym tonie. Tak samo jak na pianinie - klawisze 
znajdujące się po lewej stronie instrumentu grają nuty o niższym brzmieniu 
a klawisze znajdujące się po prawej stronie grają nuty o wyższym brzmieniu. 
I faktycznie tak jest, powyższe liczby odpowiadają nutom na pianinie. 
Kod `play 47` znaczy nic innego jak - zagraj nutę znajdującą się pod 
47 klawiszem na pianinie. Oznacza to, że kod `play 48` to dźwięk o jedną 
nutę wyżej (następny klawisz po prawej). Tak się składa, że nuta C w 4-tej 
oktawie odpowiada liczbie 60. Smiało, spróbuj zagrać ten dźwięk: 

`play 60`.

*Nie przejmuj się* jeśli nic z tego nie rozumiesz - ja również nie rozumiałem 
gdy zaczynałem na poczatku tak jak Ty teraz. Wszystko co się teraz liczy to to, 
że wiesz, że *małe liczby powodują bipy o niskim brzmieniu* a *duże liczby 
powodują bipy o wyższym brzmieniu*. 

## Akordy

Zagranie nuty jest całkiem fajne, ale zagranie kilku jednocześnie może 
być jeszcze fajniejsze. Spróbuj:

```
play 72
play 75
play 79
```

Super! Zauważ, że kiedy napiszesz kilka razy komendę `play`, wszytkie dźwięki 
zagrają w tym samym momencie. Teraz spróbuj sam - które liczby brzmią razem 
dobrze? Które brzmią okropnie? Eksperymentuj, odkrywaj i przekonaj się 
na własnej skórze.

## Melodia

Granie nut i akordów jest fajne - a co powiesz na zagranie melodii? 
Co jeśli chciałbyś zagrać jedną nutę po drugiej ale nie w tym samym 
czasie? Nic prostszego, wystarczy że odczekasz kawałek czasu pomiędzy 
poszczególnymi nutami używając polecenia `sleep`:

```
play 72
sleep 1
play 75
sleep 1
play 79
```

Cudownie, właśnie stworzyłeś małe arpeggio. No dobrze, ale co oznacza liczba 
`1` w poleceniu `sleep 1`? Oznacza to *długość trwania odstępu pomiędzy 
nutami*. Zasadniczo oznacza to odstęp o długości jednego uderzenia, 
ale póki co możesz myśleć o tym jako o przeczekaniu 1-ną sekundę. 
Co powinniśmy w takim razie zrobić jeśli chcielibyśmy trochę przyśpieszyć 
nasze arpeggio? Jedyne co musimy zrobić to użyć "krótszych" wartości 
dla polecenia sleep. Weźmy na przykład połowę, czyli wartość `0.5`:

```
play 72
sleep 0.5
play 75
sleep 0.5
play 79
```

Zauważ, że arpeggio gra teraz szybciej. Teraz twoja kolej, pobaw się tym 
kawałkiem kodu zmieniając czasy na takie jak uważasz, tak jak wcześniej 
spróbuj użyć przy tym różnych nut.

Jest jedna rzecz, którą szczególnie warto wypróbować. Spróbuj użyć nut, które 
są "pomiędzy" całymi nutami, np. `play 52.3`, `play 52.63`. Nie ma absolutnie 
żadnej konieczności, abyś kurczowo trzymał się standardowych pełnych nut. 
Kombinuj z różnymi wartościami i baw się dobrze.

## Tradycyjne Nazwy Nut

Osoby, które aktualnie znają już trochę notację muzyczną (nie przejmuj 
się jeśli Ty nie znasz - nie musisz, żeby móc się dobrze bawić) być może 
będą preferować pisanie melodii przy wykorzystaniu standardowych nazw nut,  
np. C lub F# (Fis) zamiast używania liczb. Sonic Pi pozwala na to. Nic 
nie stoi na przeszkodzie abyś napisał i uruchomił taki kod:

```
play :C
sleep 0.5
play :D
sleep 0.5
play :E
```

Pamiętaj tylko, że by umieścić dwukropek `:` tuż przed nazwą twojej nuty. 
Spowoduje to, że zmieni ona kolor na różowy. Możesz również zdefiniować 
oktawę umieszczająć odpowiednią liczbę tuż po nazwie nuty:

```
play :C3
sleep 0.5
play :D3
sleep 0.5
play :E4
```

Jeśli chcesz sprawić aby nuta brzmiała o pół tonu wyżej (uzyskanie dźwięku
fis), dodaj `s` tuż za twoją nutą, np. `play :Fs3`. Analogicznie - jeśli 
chcesz obniżyć dźwięk nuty o połowę (uzyskanie dźwięku mol), dodaj na końcu 
twojej nuty `b`, np. `play :Eb3`

A teraz *czas poszaleć*. Możesz zacząć bawić się w tworzenie twoich 
własnych melodii.
