3.6 Sample Zewnętrzne

# Sample Zewnętrzne

Podczas gdy wbudowane sample pomogą Ci zacząć dość szybko, być może chciałbyś 
poeksperymentować z innymi nagraniami, które posiadasz w swojej bibliotece 
muzycznej. Sonic Pi całkowicie to wspiera. Zanim jednak pokażemy jak można tego 
dokonać, przeprowadźmy krótką dyskusję dotyczącą przenośności twoich utworów.

## Przenośność

Kiedy komponujesz twoje utwory opierając się tylko i wyłącznie na wbudowanych 
syntezatorach i samplach, kod jest jedyną rzeczą, która jest niezbędna aby 
wiernie odtworzyć twoją muzykę. Pomyśl o tym przez chwilę - to jest 
niesamowite! Prosty kawałek tekstu, który możesz wysłać pocztą lub trzymać 
jako [Gist](https://gist.github.com) przedstawia wszystko czego potrzebujesz 
aby odtworzyć twoje kawałki. Takie podejście sprawia, że *dzielenie się 
tą muzyką z twoimi znajomymi jest naprawdę proste*, gdyż jedyne co muszą 
zrobić to zdobyć kod.

Jednakże, gdy zaczniesz używać swoich własnych sampli, stracisz 
tę przenośność. Stanie się tak dlatego, że do odtworzenia twojej muzyki 
inni ludzie będą potrzebować nie tylko twojego kodu, będą potrzebować również 
twoich sampli. Takie podejście ogranicza innymi możliwość manipulowania, 
zmieniania i eksperymentowania z twoją pracą. Oczywiście nie powinno to 
powstrzymać Cię od używania własnych sampli, to tylko coś co musisz 
wziąć pod uwagę, gdy się na to zdecydujesz.

<!-- ## Freesound Support -->

<!-- One way to get the ability to experiment with new sounds whilst keeping -->
<!-- code portability is to use the [Freesound](http:freesound.org) -->
<!-- support. http://freesound.org is a website which allows people to upload -->
<!-- and share their samples. Each sample uploaded gets a special number -->
<!-- (kind of like a phone number) which you can use to dial up that sample -->
<!-- from Sonic Pi. The only drawback is that you need to have internet -->
<!-- access for it to work. -->

<!-- If you currently have internet access, try it for yourself: -->

<!-- ``` -->
<!-- freesound 24787 -->
<!-- ``` -->

<!-- The first time you do this you'll hear a standard `:elec_beep` as a -->
<!-- placeholder for the sound. Y -->


## Sample Lokalne

W jaki sposób możesz więc zagrać dowolny plik WAV lub AIFF, który 
znajduje się na twoim komputerze? Jedyne co musisz zrobic to przekazać 
ścieżkę do tego pliku do polecenia `sample`: 

```
sample "/Users/sam/Desktop/my-sound.wav"
```

Sonic Pi automatycznie załaduję i zagra wybrany sampel. Możesz również 
przekazać wszystkie standardowe parametry, które do tej pory przekazywałeś 
do polecenia `sample`:

```
sample "/Users/sam/Desktop/my-sound.wav", rate: 0.5, amp: 0.3
```
